Index: BasicCompiler64/Compile_Var.cpp
===================================================================
--- BasicCompiler64/Compile_Var.cpp	(revision 3)
+++ BasicCompiler64/Compile_Var.cpp	(revision 9)
@@ -754,5 +754,9 @@
 	LONG_PTR lpCalcIndex;
 
-	CalcType=StaticCalculation(true, InitBuf,type,&i64data,&lpCalcIndex);
+	CalcType=StaticCalculation(false, InitBuf,type,&i64data,&lpCalcIndex);
+	if(!CalcType){
+		//動的データだった場合
+		return 0;
+	}
 	if(IsRealNumberType(CalcType)){
 		memcpy(&dbl,&i64data,sizeof(double));
@@ -876,5 +880,9 @@
 	int CalcType;
 	LONG_PTR lpCalcIndex;
-	CalcType=StaticCalculation(true, InitBuf,type,&i64data,&lpCalcIndex);
+	CalcType=StaticCalculation(false, InitBuf,type,&i64data,&lpCalcIndex);
+	if(!CalcType){
+		//動的データだった場合
+		return 0;
+	}
 	if(IsRealNumberType(CalcType)){
 		memcpy(&dbl,&i64data,sizeof(double));
@@ -983,7 +991,34 @@
 	extern HANDLE hHeap;
 	int i2,i3,VarSize;
+	char VarName[VN_SIZE];
+
+
+	if(dwFlag & DIMFLAG_CONST){
+		//////////////////////////////////
+		// 定数変数の場合を考慮
+		//////////////////////////////////
+		for(i2=0;;i2++){
+			if(Parameter[i2] == '=' ||
+				Parameter[i2] == 1 && Parameter[i2] == ESC_AS ||
+				Parameter[i2] =='('){
+					VarName[i2] = 0;
+					break;
+			}
+			VarName[i2] = Parameter[i2];
+		}
+
+		//定数と２重定義されていないる場合は抜け出す
+		if(CDBConst::obj.GetType(VarName)){
+			return;
+		}
+
+		//定数マクロとして定義されている場合は抜け出す
+		if(GetConstHash(VarName)){
+			return;
+		}
+	}
+
 
 	//構文を解析
-	char VarName[VN_SIZE];
 	int SubScripts[MAX_ARRAYDIM];
 	TYPEINFO TypeInfo;
@@ -993,13 +1028,21 @@
 		return;
 
+
+	//定数と２重定義されていないかを調べる
+	if(CDBConst::obj.GetType(VarName)){
+		SetError(15,VarName,cp);
+		return;
+	}
+
+	//定数マクロとして定義されている場合
+	if(GetConstHash(VarName)){
+		SetError(15,VarName,cp);
+		return;
+	}
+
+
 	//タイプサイズを取得
 	int TypeSize;
 	TypeSize=GetTypeSize(TypeInfo.type,TypeInfo.u.lpIndex);
-
-	//定数と２重定義されていないかを調べる
-	if(GetConstHash(VarName)){
-		SetError(15,VarName,cp);
-		return;
-	}
 
 	if(dwFlag&DIMFLAG_STATIC){
@@ -1059,31 +1102,42 @@
 			if(VarSize%8) VarSize+=8-(VarSize%8);
 
+			VARIABLE *pVar = &LocalVar[MaxLocalVarNum];
+
+			MaxLocalVarNum++;
+
 			//変数データを追加
-			lstrcpy(LocalVar[MaxLocalVarNum].name,VarName);
-			LocalVar[MaxLocalVarNum].fRef=0;
-			if(SubScripts[0]==-1) LocalVar[MaxLocalVarNum].bArray=0;
-			else LocalVar[MaxLocalVarNum].bArray=1;
-			LocalVar[MaxLocalVarNum].type=TypeInfo.type;
-			LocalVar[MaxLocalVarNum].u.index=TypeInfo.u.lpIndex;
+			lstrcpy(pVar->name,VarName);
+			pVar->fRef=0;
+			if(dwFlag & DIMFLAG_CONST) pVar->bConst = 1;
+			else pVar->bConst = 0;
+			if(SubScripts[0]==-1) pVar->bArray=0;
+			else pVar->bArray=1;
+			pVar->type=TypeInfo.type;
+			pVar->u.index=TypeInfo.u.lpIndex;
 			AllLocalVarSize+=VarSize;
-			LocalVar[MaxLocalVarNum].offset=AllLocalVarSize;
+			pVar->offset=AllLocalVarSize;
 
 			//レキシカルスコープ
-			LocalVar[MaxLocalVarNum].ScopeLevel=obj_LexScopes.GetNowLevel();
-			LocalVar[MaxLocalVarNum].ScopeStartAddress=obj_LexScopes.GetStartAddress();
-			LocalVar[MaxLocalVarNum].bLiving=TRUE;
+			pVar->ScopeLevel=obj_LexScopes.GetNowLevel();
+			pVar->ScopeStartAddress=obj_LexScopes.GetStartAddress();
+			pVar->bLiving=TRUE;
 
 			if(InitBuf[0]){
-				InitLocalVar(-LocalVar[MaxLocalVarNum].offset,
-					LocalVar[MaxLocalVarNum].type,
-					LocalVar[MaxLocalVarNum].u.index,
-					LocalVar[MaxLocalVarNum].SubScripts,
+				int result = InitLocalVar(-pVar->offset,
+					pVar->type,
+					pVar->u.index,
+					pVar->SubScripts,
 					InitBuf);
+
+				if(!result){
+					//動的な式だった場合は代入演算を行う
+					char temporary[8192];
+					sprintf(temporary,"%s=%s",VarName,InitBuf);
+					OpcodeCalc(temporary);
+				}
 			}
 			else{
 				//0初期化未完成
 			}
-
-			MaxLocalVarNum++;
 		}
 