Index: ProjectEditor/DialogBoxes.cpp
===================================================================
--- ProjectEditor/DialogBoxes.cpp	(revision 3)
+++ ProjectEditor/DialogBoxes.cpp	(revision 22)
@@ -2146,14 +2146,11 @@
 #endif
 
-	if(bProfessional){
-		//Web検索に関するオプションはPro版のみ表示
-		i++;
-		psp[i].dwSize=sizeof(PROPSHEETPAGE);
-		psp[i].dwFlags=PSP_DEFAULT;
-		psp[i].hInstance=hResInst;
-		psp[i].pszTemplate=MAKEINTRESOURCE(IDD_OPTION_WEB);
-		psp[i].pfnDlgProc=Dlg_Option_Web;
-		hpsp[i]=CreatePropertySheetPage(&psp[i]);
-	}
+	i++;
+	psp[i].dwSize=sizeof(PROPSHEETPAGE);
+	psp[i].dwFlags=PSP_DEFAULT;
+	psp[i].hInstance=hResInst;
+	psp[i].pszTemplate=MAKEINTRESOURCE(IDD_OPTION_WEB);
+	psp[i].pfnDlgProc=Dlg_Option_Web;
+	hpsp[i]=CreatePropertySheetPage(&psp[i]);
 
 	i++;
@@ -2198,31 +2195,4 @@
 		SetDlgItemText(hwnd,IDC_STATIC_VERSION,temporary);
 
-#ifdef THETEXT
-		if(bProfessional){
-			lstrcpy(temporary,"  このアプリケーションはすべての機能を利用可能なPro版です。");
-			ShowWindow(GetDlgItem(hwnd,IDC_GOPRO),SW_HIDE);
-		}
-		else{
-#ifdef SHAREWARE
-			lstrcpy(temporary,"  機能制限がかかったスタンダードモードで動作しています。Pro版のご購入手続きを行っていただくことで、提供される機能のすべてをご利用いただけます。");
-#else
-			lstrcpy(temporary,"  このアプリケーションは基本機能を備えたStandard版です。より高機能なPro版をご検討の方は、下のボタンをクリックしてください。");
-#endif
-			ShowWindow(GetDlgItem(hwnd,IDC_GOPRO),SW_SHOW);
-		}
-#else //THETEXT
-		if(bProfessional){
-			lstrcpy(temporary,"  このアプリケーションはすべての機能を利用可能なPro版です。");
-			ShowWindow(GetDlgItem(hwnd,IDC_GOPRO),SW_HIDE);
-			ShowWindow(GetDlgItem(hwnd,IDC_INPUT_PASSWORD),SW_HIDE);
-		}
-		else{
-			lstrcpy(temporary,"  このアプリケーションは基本機能を備えたStandard版です。TheText Proをご購入いただくことによって、ProjectEditor Proへの拡張機能を行うことができます。");
-			ShowWindow(GetDlgItem(hwnd,IDC_GOPRO),SW_SHOW);
-			ShowWindow(GetDlgItem(hwnd,IDC_INPUT_PASSWORD),SW_SHOW);
-		}
-#endif
-		SetDlgItemText(hwnd,IDC_NOTE,temporary);
-
 
 #ifndef THETEXT
@@ -2237,61 +2207,6 @@
 				EndDialog(hwnd,NULL);
 				return 1;
-			case IDC_GOPRO:
-				ShellExecute(hwnd,"open","http://www.discoversoft.net/thetext_pro.html",NULL,NULL,SW_SHOWNORMAL);
-				return 1;
-#ifndef THETEXT
-			//ProjectEditorのみ
-			case IDC_INPUT_PASSWORD:
-				if(DialogBox(hResInst,MAKEINTRESOURCE(IDD_PASSWORD),hwnd,DlgPassword)){
-					WriteSerialHash();
-
-					MessageBox(hwnd,"シリアルIDを正常に認証致しました。\n次回起動時から、機能拡張が施されたProモードでProjectEditorをご利用いただくことができます。",APPLICATION_NAME,MB_OK);
-					EnableWindow(GetDlgItem(hwnd,IDC_INPUT_PASSWORD),0);
-				}
-				return 1;
-#endif
 		}
 	}
 	return 0;
 }
-BOOL CALLBACK DlgPassword(HWND hwnd,UINT message,WPARAM wParam,LPARAM lParam){
-	switch(message){
-		case WM_INITDIALOG:
-			SetPosCenter(GetDesktopWindow(),hwnd);
-			SetFocus(GetDlgItem(hwnd,IDC_PASSWORD));
-			break;
-		case WM_COMMAND:
-			switch(LOWORD(wParam)){
-				case IDOK:
-					char temporary[255];
-					GetDlgItemText(hwnd,IDC_PASSWORD,temporary,255);
-
-					if(!SerialCheck(temporary)){
-						MessageBox(hwnd,"入力されたシリアルIDが正しくありません。",APPLICATION_NAME,MB_OK);
-						return 1;
-					}
-					EndDialog(hwnd,1);
-					return 1;
-				case IDCANCEL:
-					EndDialog(hwnd,0);
-					return 1;
-			}
-			return 0;
-	}
-	return 0;
-}
-BOOL CALLBACK DlgProfessionalStart(HWND hwnd,UINT message,WPARAM wParam,LPARAM lParam){
-	switch(message){
-		case WM_INITDIALOG:
-			SetPosCenter(GetDesktopWindow(),hwnd);
-			break;
-		case WM_COMMAND:
-			switch(LOWORD(wParam)){
-				case IDCANCEL:
-					EndDialog(hwnd,0);
-					return 1;
-			}
-			return 0;
-	}
-	return 0;
-}